package com.elephant.framework.galaxy.aroad.module.zhjc.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.module.zhjc.entity.ZhjcZljcZcqgh;
import com.elephant.framework.galaxy.aroad.module.zhjc.service.ZhjcZljcZcqghService;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;


/**
 * 中长期规划路线
 *
 * @author zyw
 * @date 2019-04-22 10:57:21
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhjc/zhjczljczcqgh")
public class ZhjcZljcZcqghController extends BaseController  {

  private final ZhjcZljcZcqghService zhjcZljcZcqghService;

  /**
   * 查询国道数据

   * @param zhjcZljcZcqgh 中长期规划路线
   * @return
   */
  @GetMapping("/list")
  public R getGdList(ZhjcZljcZcqgh zhjcZljcZcqgh) {
    Map<String,List<ZhjcZljcZcqgh>> map = new HashMap<>();
    List<ZhjcZljcZcqgh>   list = zhjcZljcZcqghService.list();
    List<ZhjcZljcZcqgh>  sdfx = list.stream().filter(a -> "国道".equals(a.getLxjb())&&"首都放射线".equals(a.getLxlx())).collect(Collectors.toList());
    List<ZhjcZljcZcqgh>  gdhx = list.stream().filter(a -> "国道".equals(a.getLxjb())&&"横线".equals(a.getLxlx())).collect(Collectors.toList());
    List<ZhjcZljcZcqgh>  gdzx = list.stream().filter(a -> "国道".equals(a.getLxjb())&&"纵线".equals(a.getLxlx())).collect(Collectors.toList());
    List<ZhjcZljcZcqgh>  gdllx = list.stream().filter(a -> "国道".equals(a.getLxjb())&&"联络线".equals(a.getLxlx())).collect(Collectors.toList());
    List<ZhjcZljcZcqgh>  shfx = list.stream().filter(a -> "省道".equals(a.getLxjb())&&"省会放射线".equals(a.getLxlx())).collect(Collectors.toList());
    List<ZhjcZljcZcqgh>  sdhx = list.stream().filter(a -> "省道".equals(a.getLxjb())&&"横线".equals(a.getLxlx())).collect(Collectors.toList());
    List<ZhjcZljcZcqgh>  sdzx = list.stream().filter(a -> "省道".equals(a.getLxjb())&&"纵线".equals(a.getLxlx())).collect(Collectors.toList());
    List<ZhjcZljcZcqgh>  sdllx = list.stream().filter(a -> "省道".equals(a.getLxjb())&&"联络线".equals(a.getLxlx())).collect(Collectors.toList());
    map.put("sdfx",sdfx);
    map.put("gdhx",gdhx);
    map.put("gdzx",gdzx);
    map.put("gdllx",gdllx);

    map.put("shfx",shfx);
    map.put("sdhx",sdhx);
    map.put("sdzx",sdzx);
    map.put("sdllx",sdllx);
    return  new R<>(map);
  }


  /**
   * 通过id查询中长期规划路线
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") Integer id){
    return new R<>(zhjcZljcZcqghService.getById(id));
  }

  /**
   * 新增中长期规划路线
   * @param zhjcZljcZcqgh 中长期规划路线
   * @return R
   */
  @SysLog("新增中长期规划路线")
  @PostMapping
  public R save(@RequestBody ZhjcZljcZcqgh zhjcZljcZcqgh){
    return new R<>(zhjcZljcZcqghService.save(zhjcZljcZcqgh));
  }

  /**
   * 修改中长期规划路线
   * @param zhjcZljcZcqgh 中长期规划路线
   * @return R
   */
  @SysLog("修改中长期规划路线")
  @PutMapping
  public R updateById(@RequestBody ZhjcZljcZcqgh zhjcZljcZcqgh){
    return new R<>(zhjcZljcZcqghService.updateById(zhjcZljcZcqgh));
  }

  /**
   * 通过id删除中长期规划路线
   * @param id id
   * @return R
   */
  @SysLog("删除中长期规划路线")
  @DeleteMapping("/{id}")
  public R removeById(@PathVariable Integer id){
    return new R<>(zhjcZljcZcqghService.removeById(id));
  }

}
